diff --git a/include/resolv.h b/include/resolv.h
index a70e9e5723..4d328fe914 100644
--- a/include/resolv.h
+++ b/include/resolv.h
@@ -54,7 +54,6 @@ libresolv_hidden_proto (__p_type)
 libresolv_hidden_proto (__loc_ntoa)
 libresolv_hidden_proto (__fp_nquery)
 libresolv_hidden_proto (__fp_query)
-libresolv_hidden_proto (__res_nameinquery)
 libresolv_hidden_proto (__res_queriesmatch)
 libresolv_hidden_proto (__b64_ntop)
 libresolv_hidden_proto (__dn_count_labels)
@@ -67,6 +66,8 @@ extern __typeof (res_dnok) __libc_res_dnok;
 libc_hidden_proto (__libc_res_dnok)
 extern __typeof (res_hnok) __libc_res_hnok;
 libc_hidden_proto (__libc_res_hnok)
+extern __typeof (__res_nameinquery) __libc_res_nameinquery;
+libc_hidden_proto (__libc_res_nameinquery)
 
 # endif /* _RESOLV_H_ && !_ISOMAC */
 #endif
diff --git a/resolv/Makefile b/resolv/Makefile
index 744da951ae..c4c59dcac0 100644
--- a/resolv/Makefile
+++ b/resolv/Makefile
@@ -52,6 +52,7 @@ routines := \
   res_hconf \
   res_init \
   res_libc \
+  res_nameinquery \
   res_randomid \
   resolv_conf \
   resolv_context \
diff --git a/resolv/Versions b/resolv/Versions
index 2201d4224c..f3482793dd 100644
--- a/resolv/Versions
+++ b/resolv/Versions
@@ -76,6 +76,7 @@ libc {
     __libc_ns_samename;
     __libc_res_dnok;
     __libc_res_hnok;
+    __libc_res_nameinquery;
     __ns_name_compress;
     __ns_name_ntop;
     __ns_name_pack;
diff --git a/resolv/res_nameinquery.c b/resolv/res_nameinquery.c
new file mode 100644
index 0000000000..c8404ea9d6
--- /dev/null
+++ b/resolv/res_nameinquery.c
@@ -0,0 +1,115 @@
+/* Check if a DNS packet matches a specific DNS query.
+   Copyright (C) 2016-2021 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+/*
+ * Copyright (c) 1985, 1989, 1993
+ *    The Regents of the University of California.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 4. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+/*
+ * Portions Copyright (c) 1993 by Digital Equipment Corporation.
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the above
+ * copyright notice and this permission notice appear in all copies, and that
+ * the name of Digital Equipment Corporation not be used in advertising or
+ * publicity pertaining to distribution of the document or software without
+ * specific, written prior permission.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND DIGITAL EQUIPMENT CORP. DISCLAIMS ALL
+ * WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS.   IN NO EVENT SHALL DIGITAL EQUIPMENT
+ * CORPORATION BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
+ * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
+ * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
+ * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
+ * SOFTWARE.
+ */
+
+/*
+ * Portions Copyright (c) 1996-1999 by Internet Software Consortium.
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the above
+ * copyright notice and this permission notice appear in all copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND INTERNET SOFTWARE CONSORTIUM DISCLAIMS
+ * ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL INTERNET SOFTWARE
+ * CONSORTIUM BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
+ * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
+ * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
+ * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
+ * SOFTWARE.
+ */
+
+#include <arpa/nameser.h>
+#include <resolv.h>
+
+/* Author: paul vixie, 29may94.  */
+int
+__libc_res_nameinquery (const char *name, int type, int class,
+                        const unsigned char *buf, const unsigned char *eom)
+{
+  const unsigned char *cp = buf + HFIXEDSZ;
+  int qdcount = ntohs (((HEADER *) buf)->qdcount);
+
+  while (qdcount-- > 0)
+    {
+      char tname[MAXDNAME+1];
+      int n, ttype, tclass;
+
+      n = __libc_dn_expand (buf, eom, cp, tname, sizeof tname);
+      if (n < 0)
+        return -1;
+      cp += n;
+      if (cp + 2 * INT16SZ > eom)
+        return -1;
+      NS_GET16 (ttype, cp);
+      NS_GET16 (tclass, cp);
+      if (ttype == type && tclass == class
+          && __libc_ns_samename (tname, name) == 1)
+        return 1;
+    }
+  return 0;
+}
+libc_hidden_def (__libc_res_nameinquery)
diff --git a/resolv/res_send.c b/resolv/res_send.c
index dfea9fc7fa..a5a33e6f3b 100644
--- a/resolv/res_send.c
+++ b/resolv/res_send.c
@@ -191,47 +191,6 @@ static int		send_dg(res_state, const u_char *, int,
 				u_char **, int *, int *, int *);
 static int		sock_eq(struct sockaddr_in6 *, struct sockaddr_in6 *);
 
-/* Public. */
-
-/* int
- * res_nameinquery(name, type, class, buf, eom)
- *	look for (name,type,class) in the query section of packet (buf,eom)
- * requires:
- *	buf + HFIXEDSZ <= eom
- * returns:
- *	-1 : format error
- *	0  : not found
- *	>0 : found
- * author:
- *	paul vixie, 29may94
- */
-int
-res_nameinquery(const char *name, int type, int class,
-		const u_char *buf, const u_char *eom)
-{
-	const u_char *cp = buf + HFIXEDSZ;
-	int qdcount = ntohs(((HEADER*)buf)->qdcount);
-
-	while (qdcount-- > 0) {
-		char tname[MAXDNAME+1];
-		int n, ttype, tclass;
-
-		n = __libc_dn_expand (buf, eom, cp, tname, sizeof tname);
-		if (n < 0)
-			return (-1);
-		cp += n;
-		if (cp + 2 * INT16SZ > eom)
-			return (-1);
-		NS_GET16(ttype, cp);
-		NS_GET16(tclass, cp);
-		if (ttype == type && tclass == class
-		    && __libc_ns_samename (tname, name) == 1)
-			return (1);
-	}
-	return (0);
-}
-libresolv_hidden_def (res_nameinquery)
-
 /* Returns a shift value for the name server index.  Used to implement
    RES_ROTATE.  */
 static unsigned int
@@ -337,7 +296,7 @@ res_queriesmatch(const u_char *buf1, const u_char *eom1,
 			return (-1);
 		NS_GET16(ttype, cp);
 		NS_GET16(tclass, cp);
-		if (!res_nameinquery(tname, ttype, tclass, buf2, eom2))
+		if (!__libc_res_nameinquery (tname, ttype, tclass, buf2, eom2))
 			return (0);
 	}
 	return (1);
diff --git a/resolv/resolv-deprecated.c b/resolv/resolv-deprecated.c
index d8344f8f39..0fe9e4fda6 100644
--- a/resolv/resolv-deprecated.c
+++ b/resolv/resolv-deprecated.c
@@ -27,6 +27,7 @@
    functions.  */
 
 #include <arpa/nameser.h>
+#include <resolv.h>
 
 int
 ns_makecanon (const char *src, char *dst, size_t dstsize)
@@ -39,3 +40,10 @@ ns_samename (const char *a, const char *b)
 {
   return __libc_ns_samename (a, b);
 }
+
+int
+res_nameinquery (const char *name, int type, int class,
+                 const unsigned char *buf, const unsigned char *eom)
+{
+  return __libc_res_nameinquery (name, type, class, buf, eom);
+}